/*	memory.h

	Copyright 2008 Fred Cooke

	This file is part of the FreeEMS project.

	FreeEMS software is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	FreeEMS software is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with any FreeEMS software.  If not, see <http://www.gnu.org/licenses/>.

	We ask that if you make any changes to this file you send them upstream to us at admin@diyefi.org

	Thank you for choosing FreeEMS to run your engine! */

/* Header file multiple inclusion protection courtesy eclipse Header Template	*/
/* and http://gcc.gnu.org/onlinedocs/gcc-3.1.1/cpp/ C pre processor manual		*/
#ifndef FILE_MEMORY_H_SEEN
#define FILE_MEMORY_H_SEEN

/* http://gcc.gnu.org/onlinedocs/gcc-4.0.0/gcc/Variable-Attributes.html	*/

// EEPROM
#define EEPROM __attribute__ ((section (".eeprom")))

// Direct flash blocks
#define TEXT1 __attribute__ ((section (".text1")))
//* #define TEXT __attribute__ ((section (".text"))) Not required, code defaults to being stored there. */

/* far shortcut */
#define FAR(label) __attribute__ ((far)) __attribute__ ((section (label)))

// Paged flash blocks
#define PPAGE_E0 FAR(".ppageE0")
#define PPAGE_E1 FAR(".ppageE1")
#define PPAGE_E2 FAR(".ppageE2")
#define PPAGE_E3 FAR(".ppageE3")
#define PPAGE_E4 FAR(".ppageE4")
#define PPAGE_E5 FAR(".ppageE5")
#define PPAGE_E6 FAR(".ppageE6")
#define PPAGE_E7 FAR(".ppageE7")
#define PPAGE_E8 FAR(".ppageE8")
#define PPAGE_E9 FAR(".ppageE9")
#define PPAGE_EA FAR(".ppageEA")
#define PPAGE_EB FAR(".ppageEB")
#define PPAGE_EC FAR(".ppageEC")
#define PPAGE_ED FAR(".ppageED")
#define PPAGE_EE FAR(".ppageEE")
#define PPAGE_EF FAR(".ppageEF")
#define PPAGE_F0 FAR(".ppageF0")
#define PPAGE_F1 FAR(".ppageF1")
#define PPAGE_F2 FAR(".ppageF2")
#define PPAGE_F3 FAR(".ppageF3")
#define PPAGE_F4 FAR(".ppageF4")
#define PPAGE_F5 FAR(".ppageF5")
#define PPAGE_F6 FAR(".ppageF6")
#define PPAGE_F7 FAR(".ppageF7")
#define PPAGE_F8 FAR(".ppageF8")
#define PPAGE_F9 FAR(".ppageF9")
#define PPAGE_FA FAR(".ppageFA")
#define PPAGE_FB FAR(".ppageFB")
#define PPAGE_FC FAR(".ppageFC")
#define PPAGE_FE FAR(".ppageFE")
/* #define PPAGE_FD FAR(".ppageFD") Represents 0x4000 - 0x7FFF (TEXT1 paged) */
/* #define PPAGE_FF FAR(".ppageFF") Represents 0xC000 - 0xFFFF (TEXT paged) */
/* The previous two lines are included for clarity only. */
/* Changes to the memory layout should be reflected in memory.x and Makefile also */

#else
	/* let us know if we are being untidy with headers */
	#warning "Header file MEMORY_H seen before, sort it out!"
/* end of the wrapper ifdef from the very top */
#endif
