/*	structs.h

	Copyright 2008 Fred Cooke

	This file is part of the FreeEMS project.

	FreeEMS software is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	FreeEMS software is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with any FreeEMS software.  If not, see <http://www.gnu.org/licenses/>.

	We ask that if you make any changes to this file you send them upstream to us at admin@diyefi.org

	Thank you for choosing FreeEMS to run your engine! */

/* Header file multiple inclusion protection courtesy eclipse Header Template	*/
/* and http://gcc.gnu.org/onlinedocs/gcc-3.1.1/cpp/ C pre processor manual		*/
#ifndef FILE_STRUCTS_H_SEEN
#define FILE_STRUCTS_H_SEEN


/* Use this block to ensure that the components are contiguous and we can then reference them via offsets and pointers */
struct ADCArray {
	
/* ADC0 variables */
unsigned short IAT[IN_OUT_BANKS];			/* Inlet Air Temperature (MAT JS)			: 0.0	-    655.35		(0.01 Kelvin (/100))		*/
unsigned short CHT[IN_OUT_BANKS];			/* Coolant / Head Temperature (CLT JS)		: 0.0	-    655.35		(0.01 Kelvin (/100))		*/
unsigned short TPS[IN_OUT_BANKS];			/* Throttle Position Sensor (TPS JS)		: 0.0	-    102.39		(0.001? % (/640))			*/
unsigned short EGO[IN_OUT_BANKS];			/* Exhaust Gas Oxygen (O2 JS)				: 0.000	-      1.999999	(0.0001? lambda (/32768))	*/
unsigned short BRV[IN_OUT_BANKS];			/* Battery Reference Voltage (4euroh1)		: 0.000	-     65.535	(0.001 Volts (/1000))		*/
unsigned short MAP[IN_OUT_BANKS];			/* Manifold Absolute Pressure (5euroh1)		: 0.0	-    655.35		(0.01 kPa (/100))			*/
unsigned short AAP[IN_OUT_BANKS];			/* Atmospheric Absolute Pressure (6euroh1)	: 0.0	-    655.35		(0.01 kPa (/100))			*/
unsigned short SpareADC[IN_OUT_BANKS];		/* Spare ADC0 port 7 (SPARE JS)				: 0		-   65535		(1)							*/

/* ADC1 variables */
unsigned short SpareADC0[IN_OUT_BANKS];		/* Spare ADC1 port 0 (NC)					: 0		-   65535		(1)							*/
unsigned short SpareADC1[IN_OUT_BANKS];		/* Spare ADC1 port 1 (NC)					: 0		-   65535		(1)							*/
unsigned short SpareADC2[IN_OUT_BANKS];		/* Spare ADC1 port 2 (NC)					: 0		-   65535		(1)							*/
unsigned short SpareADC3[IN_OUT_BANKS];		/* Spare ADC1 port 3 (NC)					: 0		-   65535		(1)							*/
unsigned short SpareADC4[IN_OUT_BANKS];		/* Spare ADC1 port 4 (NC)					: 0		-   65535		(1)							*/
unsigned short SpareADC5[IN_OUT_BANKS];		/* Spare ADC1 port 5 (NC)					: 0		-   65535		(1)							*/
unsigned short SpareADC6[IN_OUT_BANKS];		/* Spare ADC1 port 6 (NC)					: 0		-   65535		(1)							*/
unsigned short SpareADC7[IN_OUT_BANKS];		/* Spare ADC1 port 7 (NC)					: 0		-   65535		(1)							*/

};


#else
	/* let us know if we are being untidy with headers */
	#warning "Header file STRUCTS_H seen before, sort it out!"
/* end of the wrapper ifdef from the very top */
#endif
